#!/bin/bash
#
#  codeCoverage.sh
#  SocketServer
#
#  Created by Justin Marshall on 6/15/24.
#  Copyright © 2024 Justin Marshall. All rights reserved.
#
#  This file is part of SocketServer.
#
#  SocketServer is free software: you can redistribute it and/or modify it under the
#  terms of the GNU Affero General Public License as published by the Free
#  Software Foundation, version 3 of the License only.
#
#  SocketServer is distributed in the hope that it will be useful, but WITHOUT ANY
#  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#  FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
#  details.
#
#  You should have received a copy of the GNU Affero General Public License along
#  with SocketServer. If not, see <https://www.gnu.org/licenses/>.
#

reportHeader() {
    VERSION=v0.0.1
    echo "+-----------------------------------------------------------+"
    echo "| Automatically generated by $0 ${VERSION}       |"
    echo "+-----------------------------------------------------------+"
    echo "| Legend: *Leakage                                          |"
    echo "+-----------------------------------------------------------+"
}

reportCodeCoverage() {
    LLVM_COV_REPORT_ARGS_COMMON=(\
        report \
        "${XCTEST_FILE:?}" \
        --instr-profile="${PROFDATA_FILE:?}" \
        --ignore-filename-regex=.build \
        --ignore-filename-regex=Tests
    )

    if [[ $1 = "--color" ]]; then
        LLVM_COV_REPORT_ARGS_COMMON+=(--use-color)
    fi

    llvm-cov "${LLVM_COV_REPORT_ARGS_COMMON[@]}"
}

reportLeakages() {
    local REPORT_TABLE=$1

    # This nasty brute-force hack filters out files with 0.00% coverage.
    # If this gets any more complicated, consider rewriting in a different language.
    #
    # The pipe (|) in the awk is a separator to prevent grep detecting things like:
    # 100.00%, 90.00%, 80.00%, etc.
    local FILE_LIST=$(\
        echo "${REPORT_TABLE:?}" |\
        sed 's/-//g' |\
        sed 's/^Filename.*//' |\
        sed 's/^TOTAL.*//' |\
        awk '{ print $1, "|", $4 }' |\
        grep -v '| 0.00%' |\
        sed 's/|[[:space:]][[:digit:]].*//' |\
        grep -v '|'
    )

    if [[ "${FILE_LIST}" = "" ]]; then
        echo No leakages detected.
        echo
        printf '%b' "${REPORT_TABLE}"
        exit 0
    fi

    for FILE in ${FILE_LIST:?} ; do
        local PROD_FILE_NAME=$(\
            echo "${FILE:?}" |\
            awk 'BEGIN { FS = "/"} { print $NF }' \
        )

        local PROD_TYPE_NAME=$(\
            echo "${PROD_FILE_NAME:?}" |\
            awk 'BEGIN { FS = "."} { print $1 }' \
        )

        local TEST_FILE_NAME="${PROD_TYPE_NAME:?}Tests.swift"
        local TEST_FILE_LOCATION=$(find ./Tests/ -type f -name "${TEST_FILE_NAME:?}")
        local ORIGINAL_LINE=$(printf '%b' "${REPORT_TABLE:?}" | grep "${PROD_FILE_NAME:?}")

        if [ -z "${TEST_FILE_LOCATION}" ]; then
            local NEW_LINE="*$(printf '%b' "${ORIGINAL_LINE:?}")"
        else
            local NEW_LINE=" $(printf '%b' "${ORIGINAL_LINE:?}")"
        fi

        REPORT_TABLE="${REPORT_TABLE//"${ORIGINAL_LINE}"/"${NEW_LINE}"}"
    done

    REPORT_TABLE=$(\
        printf '%b' "${REPORT_TABLE}" |\
        sed -r "s/^([[:alpha:]].*)/ \1/" |\
        sed "s/^ Filename/Filename /" |\
        sed "s/^ TOTAL/TOTAL /" \
    )

    printf '%b' "${REPORT_TABLE}"
}

reportAll() {
    reportHeader
    echo
    reportLeakages "$(reportCodeCoverage $1)"
}

enforceArgument() {
    if ! [[ $1 = "--color" || $1 = "--no-color" ]]; then
        echo "Usage: ${0} [--color|--no-color]"
        exit 1
    fi
}

enforceArgument $1

swift test --enable-code-coverage &> /dev/null

XCTEST_FILE=$(find . -iname '*SocketServer*.xctest')
PROFDATA_FILE=$(find . -iname 'default.profdata')

reportAll $1
